BEGIN
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ACCESS_REVIEW_DETAILS_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ACCESS_REVIEW_DETAILS_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ACCESS_REVIEW_DETAILS_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW ACCESS_REVIEW_DETAILS_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ADHOC_SUSER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ADHOC_SUSER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ADHOC_SUSER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW ADHOC_SUSER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_SPERMISSION_CERT_RISK_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_SPERMISSION_CERT_RISK_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_SPERMISSION_CERT_RISK_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW SUSER_SPERMISSION_CERT_RISK_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ADHOC_APPS_SPERMISSIONS_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ADHOC_APPS_SPERMISSIONS_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ADHOC_APPS_SPERMISSIONS_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW ADHOC_APPS_SPERMISSIONS_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'REVIEW_ITEM_STATUS_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM REVIEW_ITEM_STATUS_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'REVIEW_ITEM_STATUS_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW REVIEW_ITEM_STATUS_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SHARED_ACCOUNTS_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SHARED_ACCOUNTS_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SHARED_ACCOUNTS_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW SHARED_ACCOUNTS_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'APPLICATION_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM APPLICATION_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'APPLICATION_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW APPLICATION_PARAMETER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'PERMISSION_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM PERMISSION_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'PERMISSION_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW PERMISSION_PARAMETER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'REVIEW_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM REVIEW_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'REVIEW_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW REVIEW_PARAMETER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'REVIEWER_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM REVIEWER_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'REVIEWER_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW REVIEWER_PARAMETER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ROLE_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ROLE_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ROLE_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW ROLE_PARAMETER_V';
  END LOOP;
  FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'USER_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM USER_PARAMETER_V';
  END LOOP;
  FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'USER_PARAMETER_V') LOOP
    EXECUTE IMMEDIATE 'DROP VIEW USER_PARAMETER_V';
  END LOOP;
END;
/

CREATE VIEW shared_accounts_v AS 
  SELECT 
    acct.unique_account_id,
    saccu.suser,
    suser.display_name,
    substr(suser.dn, 4, instr(suser.dn, ',', 1, 1)-4) user_cn
  FROM saccount acct
    JOIN saccount_user saccu ON acct.collected_entity = saccu.saccount AND acct.relation_to_user_type = 'SHARED' AND acct.effective = '1'
    JOIN suser suser ON suser.collected_entity = saccu.suser AND suser.effective = '1' AND suser.deleted = '0' AND saccu.effective = '1';

CREATE VIEW access_review_details_v AS
  SELECT DISTINCT
    item.id review_item_id,
    item.last_override_action_id last_override_action,
    instance.id review_instance_id,
    instance.status review_status,
    instance.start_date,
    instance.end_date,
    instance.valid_to_date,
    instance.item_count,
    multi_owner.review_owners,
    multi_reviewer.reviewer_ids reviewer_id,
      CASE
        WHEN item.final_cert_by_unique_user_id IS NOT NULL THEN TO_CHAR(final_reviewer.display_name)
        ELSE TO_CHAR(multi_reviewer.reviewers)
      END reviewer_display_name,
      CASE
        WHEN item.final_cert_by_unique_user_id IS NOT NULL THEN TO_CHAR(substr(final_reviewer.dn, 4, instr(final_reviewer.dn, ',', 1, 1)-4))
        ELSE TO_CHAR(multi_reviewer.user_cn)
      END reviewer_cn,
    reassigned_by_history.reviewers reassigned_by_user_disp_name,
    reassigned_from_history.reviewers reassigned_from_user_disp_name,
    reassigned_by_history.reassigned_date,
    reassigned_by_history.reasons reassigned_reasons,
    reassigned_by_history.rev_comments reassigned_comments,
    defn.name review_name,
    TO_CHAR(substr(defn.description,0,4000)) description,
    defn.review_type,
    defn.next_schedule_date,
      CASE
        WHEN item.item_type = 'ACCOUNT' AND usr.id IS NULL THEN shacc.suser  
        ELSE usr.id
      END user_id,
      CASE
        WHEN item.item_type = 'ACCOUNT' AND usr.display_name IS NULL THEN TO_CHAR(shacc.display_name)
        ELSE TO_CHAR(usr.display_name)
      END user_display_name,
      CASE
        WHEN item.item_type = 'ACCOUNT' AND usr.display_name IS NULL THEN TO_CHAR(shacc.user_cn)
        ELSE TO_CHAR(substr(usr.dn, 4, instr(usr.dn, ',', 1, 1)-4))
      END user_cn,
    action.action reviewer_action,
    reason.name modify_reason_name,
    reason.id modify_reason_id,
      CASE
        WHEN fulfillment.review_item_id IS NOT NULL THEN 1
        ELSE 0
      END remove_completed,
    usr.unique_user_id,
    action.review_order,
    action.reviewer_comment,
    perm.id permission_id,
    perm.name permission_name,
    acct.id account_id,
    acct.account_id account_native_id,
    acct.name account_name,
    acct.relation_to_user_type account_relation,
    TO_CHAR(app.id) application_id,
    TO_CHAR(app_ds.name) application_name,
    item.final_decision,
    item.final_decision_time,
    role.id role_id,
    role.name role_name,
    item.item_type,
    brole.name brole_name,
    action.fulfillment_instructions,
    esc_reviewer.display_name esc_reviewer
  FROM review_item item
    JOIN review_instance instance ON item.review_instance_id = instance.id AND instance.status NOT IN ('PREVIEW', 'PREVIEW_CANCELED', 'PREVIEW_STARTING')
    JOIN (SELECT 
      review_instance.id inst_id,
      defn.id defn_id, 
      CASE WHEN staged_defn.name IS NULL THEN defn.name ELSE staged_defn.name END AS name,
      CASE WHEN staged_defn.description IS NULL THEN defn.description ELSE staged_defn.description END AS description,
      CASE WHEN staged_defn.next_schedule_date IS NULL THEN defn.next_schedule_date ELSE staged_defn.next_schedule_date END AS next_schedule_date,
      defn.review_type,
      defn.deleted
      FROM review_definition defn
      JOIN review_instance ON defn.id = review_instance.review_definition
      LEFT JOIN review_definition staged_defn ON staged_defn.id = review_instance.staged_review_definition_id) defn ON instance.id = defn.inst_id 
    LEFT JOIN suser usr ON usr.unique_user_id = item.unique_user_id AND usr.effective = 1
    LEFT JOIN spermission perm ON perm.unique_permission_id = item.unique_permission_id AND perm.effective = 1
    LEFT JOIN saccount acct ON acct.unique_account_id = item.unique_account_id AND acct.effective = 1
    LEFT JOIN application app ON app.id =
      CASE
        WHEN perm.id IS NULL THEN acct.application
        ELSE perm.application
      END
    LEFT JOIN business_role brole ON brole.id = item.business_role_id
    LEFT JOIN role_policy role ON role.id = item.role_id
    LEFT JOIN data_source app_ds ON app_ds.id = app.id
    LEFT JOIN review_item_action action ON action.review_item_id = item.id AND action.action <> 'REASSIGNED'
    LEFT JOIN review_item_action_reason reason ON reason.id = action.reason_id
    LEFT JOIN reviewer_instance inst2 ON instance.id = inst2.review_instance_id AND inst2.type = 'RO'
    LEFT JOIN reviewer_instance inst3 ON instance.id = inst3.review_instance_id
    LEFT JOIN ( SELECT DISTINCT 
      item.id item_id,
      LISTAGG((TO_CHAR(multi_reviewers.id)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.display_name) reviewer_ids,
      LISTAGG((TO_CHAR(multi_reviewers.unique_user_id)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.display_name) reviewer_unique_ids,
      LISTAGG((TO_CHAR(multi_reviewers.display_name)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.display_name) reviewers,
      LISTAGG((TO_CHAR(substr(multi_reviewers.dn, 4, instr(multi_reviewers.dn, ',', 1, 1)-4))), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.display_name) user_cn
      FROM review_item item
      LEFT JOIN reviewer_user_instance rrui ON rrui.reviewer_instance_id = item.curr_reviewer_instance_id
      LEFT JOIN suser multi_reviewers ON rrui.unique_user_id = multi_reviewers.unique_user_id AND multi_reviewers.effective = 1
      GROUP BY item.id) multi_reviewer ON multi_reviewer.item_id = item.id
    LEFT JOIN suser final_reviewer ON item.final_cert_by_unique_user_id = final_reviewer.unique_user_id AND final_reviewer.effective = 1
    LEFT JOIN suser acting_reviewer ON action.acted_by_user_unique_id = acting_reviewer.unique_user_id AND acting_reviewer.effective = 1
    LEFT JOIN review_item_action reassigned ON reassigned.review_item_id = item.id AND reassigned.action = 'REASSIGNED' AND reassigned.reassigned_to_user_unique_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%'
    LEFT JOIN suser curr_reviewer ON curr_reviewer.unique_user_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%' AND curr_reviewer.effective = 1
    LEFT JOIN (SELECT 
      ria.review_item_id,
      LISTAGG(TO_CHAR(usr.display_name), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reviewers
      FROM  review_item_action ria
      LEFT JOIN reviewer_instance ri ON ri.id = ria.reviewer_instance_id
      LEFT JOIN suser usr ON ri.single_reviewer_unique_id = usr.unique_user_id AND usr.effective = 1
      WHERE ria.action = 'REASSIGNED'
      GROUP BY ria.review_item_id) reassigned_from_history ON reassigned_from_history.review_item_id = item.id
    LEFT JOIN (SELECT 
      ria.review_item_id,
      LISTAGG(TO_CHAR(usr.display_name), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reviewers,
      LISTAGG(COALESCE(TO_CHAR(reason.name), 'NULL_REASON'), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reasons,
      LISTAGG(TO_CHAR(CAST(ria.assigned AS DATE), 'YYYY-MM-DD HH24:MI:SS'), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reassigned_date,
      LISTAGG(TO_CHAR(COALESCE (NULLIF(TO_CHAR(ria.reviewer_comment), ''), 'NULL_COMMENT')), ' | ') WITHIN GROUP (ORDER BY ria.assigned) AS rev_comments
      FROM  review_item_action ria
      LEFT JOIN review_item_action_reason reason ON ria.reason_id = reason.id
      LEFT JOIN suser usr ON ria.reassigned_by_user_unique_id = usr.unique_user_id AND usr.effective = 1
      WHERE ria.action = 'REASSIGNED'
      GROUP BY ria.review_item_id) reassigned_by_history ON reassigned_by_history.review_item_id = item.id
    LEFT JOIN shared_accounts_v shacc ON shacc.unique_account_id = acct.unique_account_id
    LEFT JOIN ( SELECT DISTINCT 
      defn_1.name review_name,
      ri.id rid,
      LISTAGG((TO_CHAR(s.display_name)), ' | ') WITHIN GROUP(ORDER BY s.display_name) review_owners
      FROM review_instance ri
      JOIN review_definition defn_1 ON ri.review_definition = defn_1.id
      LEFT JOIN reviewer_instance rev_owner ON ri.id = rev_owner.review_instance_id AND rev_owner.type = 'RO'
      LEFT JOIN reviewer_user_instance rui ON rui.reviewer_instance_id = rev_owner.id
      LEFT JOIN suser s ON rui.unique_user_id = s.unique_user_id AND s.effective = 1
      GROUP BY defn_1.name, ri.id) multi_owner ON multi_owner.rid = item.review_instance_id   
    LEFT JOIN (SELECT 
      esc_reviewers.review_instance_id,
      LISTAGG(TO_CHAR(esc_reviewers.display_name), ' | ') WITHIN GROUP (ORDER BY esc_reviewers.display_name) display_name
      FROM
        (SELECT DISTINCT
        TO_CHAR(u.display_name) display_name,
        rri.review_instance_id
        FROM review_item ri
        JOIN reviewer_instance rri ON ri.review_instance_id = rri.review_instance_id AND rri.type = 'EO'
        JOIN reviewer_user_instance rriu ON rriu.reviewer_instance_id = rri.id
        JOIN suser u ON u.unique_user_id = rriu.unique_user_id AND u.effective = 1) esc_reviewers
      GROUP BY esc_reviewers.review_instance_id) esc_reviewer ON esc_reviewer.review_instance_id = item.review_instance_id
    LEFT JOIN ( SELECT 
      review_item_id, 
      action, 
      change_item_status 
      FROM change_request_item cri
      LEFT JOIN change_item_action cia ON cri.latest_action = cia.id
      WHERE cri.change_request_type LIKE 'REMOVE' || '%' AND action = 'FULFILLED' AND (change_item_status = 'VERIFIED' OR change_item_status = 'COMPLETED')) fulfillment ON item.id = fulfillment.review_item_id
  WHERE 
    defn.deleted = 0 
    AND (acting_reviewer.unique_user_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%' OR acting_reviewer.unique_user_id IS NULL 
      AND action.review_order = 
      ( SELECT DISTINCT min(act.review_order) min
        FROM review_item_action act
        WHERE (act.action = 'PENDING' OR act.action = 'ESCALATE') AND act.review_item_id = item.id) 
      OR acting_reviewer.unique_user_id IS NOT NULL AND action.shared_queue = 1) 
    AND (action.action <> 'PENDING' OR item.final_decision IS NULL);

CREATE VIEW review_item_status_v AS 
  SELECT 
    perm.id perm_id,
    suser.id user_id,
    item.status review_status,
    MAX(item.end_date) AS last_certification
  FROM spermission perm
    JOIN (SELECT
        item.unique_permission_id,
        item.unique_user_id,
        review_instance.id,
        review_instance.status,
        review_instance.end_date
      FROM review_item item 
        JOIN review_instance ON item.review_instance_id = review_instance.id AND review_instance.status IN ('CERTIFIED', 'CERTIFYING', 'AUDIT_APPROVAL')
      WHERE item.unique_permission_id IS NOT NULL AND item.unique_user_id IS NOT NULL) item ON item.unique_permission_id = perm.unique_permission_id AND perm.effective = 1
    JOIN suser ON suser.unique_user_id = item.unique_user_id AND suser.effective = 1
  GROUP BY perm.id, suser.id, item.status;

CREATE VIEW adhoc_apps_spermissions_v AS
  SELECT 
    suser_account_permission.suser,
    suser_account_permission.saccount,
    data_source.id application_id,
    data_source.name application_name,
    data_source.description application_description,
    application.risk application_risk,
    spermission.id permission_id,
    spermission.name permission_name,
    spermission.description permission_description,
    spermission.risk permission_risk,
    spermission.type permission_type,
    certified.last_certification,
      CASE
        WHEN certified.last_certification IS NOT NULL THEN 1
        ELSE 0
      END AS is_certified,
      CASE
        WHEN certified.review_status IN ('CERTIFYING', 'AUDIT_APPROVAL') THEN 1
        ELSE 0
      END AS certification_pending
  FROM suser_account_permission
    JOIN spermission ON suser_account_permission.spermission = spermission.id AND spermission.deleted = 0 AND spermission.effective = 1
    JOIN application ON spermission.application = application.id
    JOIN data_source ON application.id = data_source.id AND data_source.data_source_type = 'APPLICATION' AND data_source.deleted = 0
    LEFT JOIN review_item_status_v certified ON suser_account_permission.suser = certified.user_id AND spermission.id = certified.perm_id;

CREATE VIEW suser_spermission_cert_risk_v AS 
  SELECT 
    spermissions.suser AS suser_id, 
    COALESCE(spermissions.is_certified, 0) AS is_certified, 
    COALESCE(spermissions.certification_pending, 0) AS certification_pending, 
    COALESCE(SUM(spermissions.permission_risk), 0) AS aggregate_permission_risk, 
    COUNT(spermissions.suser) AS certification_count 
  FROM adhoc_apps_spermissions_v spermissions 
  GROUP BY spermissions.suser, spermissions.is_certified, spermissions.certification_pending, spermissions.permission_risk;

CREATE VIEW adhoc_suser_v AS
  SELECT
    suser.id,
    suser.deleted,
    suser.department,
    suser.display_description,
    suser.display_name,
    suser.dn,
    suser.effective,
    suser.employee_status,
    suser.employee_type,
    suser.first_name,
    suser.full_name,
    suser.guid,
    suser.home_phone,
    suser.idm_dn,
    suser.idm_tree_name,
    suser.is_curated,
    suser.job_code,
    suser.job_title,
    suser.last_name,
    suser.location,
    suser.merged,
    suser.middle_name,
    suser.office_phone,
    suser.other_phone,
    suser.preferred_locale,
    suser.provisioning_id,
    suser.secondary_supervisor_id,
    suser.supervisor_attr_key,
    suser.supervisor_id,
    suser.supervisor_unique_id,
    suser.unique_user_id,
    suser.user_id,
    suser.business_unit,
    suser.collected_entity,
    suser.effective_entity,
    suser.identity_source,
    suser.sversion,
    suser.workforce_id,
    suser_email.email,
    suser.risk,
    cert_risk.certification_count,
    cert_risk.is_certified,
    cert_risk.certification_pending,
    cert_risk.aggregate_permission_risk,
    permissions.all_permissions
  FROM suser
    LEFT JOIN suser_email ON suser.id = suser_email.suser
    LEFT JOIN (SELECT 
        sap.suser,
        LISTAGG(TO_CHAR(perm.name), ' | ') WITHIN GROUP (ORDER BY perm.name) AS all_permissions
      FROM spermission perm
        JOIN suser_account_permission sap ON perm.id = sap.spermission
      GROUP BY sap.suser) permissions ON suser.id = permissions.suser
    LEFT JOIN suser_spermission_cert_risk_v cert_risk ON suser.id = cert_risk.suser_id
  WHERE suser.deleted = 0 AND suser.effective = 1;

CREATE VIEW application_parameter_v AS 
  SELECT DISTINCT 
    app.id application_id, 
    ds.name application_name
  FROM application app
    JOIN data_source ds ON  app.id = ds.id;

CREATE VIEW permission_parameter_v AS 
  SELECT DISTINCT 
    perm.id permission_id, 
    perm.name permission_name
  FROM review_item item
    JOIN spermission perm ON perm.unique_permission_id = item.unique_permission_id AND perm.effective =  1;

CREATE VIEW review_parameter_v AS 
  SELECT DISTINCT
    defn.name AS review_name,
    defn.unique_review_def_id
  FROM (SELECT
      review_instance.id inst_id,
      COALESCE(staged_defn.name, defn.name) AS name,
      defn.unique_review_def_id,
      defn.deleted
    FROM review_definition defn
      JOIN review_instance ON defn.id = review_instance.review_definition
      LEFT JOIN review_definition staged_defn ON staged_defn.id = review_instance.staged_review_definition_id) defn
  WHERE EXISTS (
    SELECT 1
    FROM review_instance ri
      JOIN review_item item ON item.review_instance_id = ri.id
    WHERE ri.id = defn.inst_id
    ) AND defn.deleted = 0;

CREATE VIEW reviewer_parameter_v AS
  SELECT DISTINCT 
    reviewer.display_name reviewer_display_name, 
    reviewer.id reviewer_id
  FROM suser reviewer 
  WHERE EXISTS (
    SELECT 1 
    FROM review_item item 
      JOIN review_instance instance on item.review_instance_id = instance.id
      JOIN reviewer_instance revr_inst on instance.id = revr_inst.review_instance_id
    WHERE revr_inst.single_reviewer_unique_id = reviewer.unique_user_id AND reviewer.effective = 1
  );

CREATE VIEW role_parameter_v AS 
  SELECT DISTINCT 
    role.id AS role_id,
    role.name AS role_name
  FROM role_policy role
  WHERE EXISTS ( 
    SELECT 1
    FROM review_item item
    WHERE item.role_id = role.id
  );

CREATE VIEW user_parameter_v AS 
  SELECT DISTINCT 
    CASE
      WHEN item.item_type = 'ACCOUNT' AND usr.id IS NULL THEN user_acct.id
      ELSE usr.id
    END AS user_id,
    CASE
      WHEN item.item_type = 'ACCOUNT' AND usr.display_name IS NULL THEN user_acct.display_name
      ELSE usr.display_name
    END AS user_display_name
  FROM review_item item
    LEFT JOIN suser usr ON usr.unique_user_id = item.unique_user_id AND usr.effective = 1
    LEFT JOIN saccount acct ON acct.unique_account_id = item.unique_account_id AND acct.effective = 1
    LEFT JOIN saccount_user acct_user ON acct_user.saccount = acct.id
    LEFT JOIN suser user_acct ON user_acct.id = acct_user.suser;

GRANT SELECT ON igops.access_review_details_v TO ig_report_role;
CREATE PUBLIC SYNONYM access_review_details_v FOR igops.access_review_details_v;

GRANT SELECT ON igops.adhoc_suser_v TO ig_report_role;
CREATE PUBLIC SYNONYM adhoc_suser_v FOR igops.adhoc_suser_v;

GRANT SELECT ON igops.suser_spermission_cert_risk_v TO ig_report_role;
CREATE PUBLIC SYNONYM suser_spermission_cert_risk_v FOR igops.suser_spermission_cert_risk_v;

GRANT SELECT ON igops.adhoc_apps_spermissions_v TO ig_report_role;
CREATE PUBLIC SYNONYM adhoc_apps_spermissions_v FOR igops.adhoc_apps_spermissions_v;

GRANT SELECT ON igops.review_item_status_v TO ig_report_role;
CREATE PUBLIC SYNONYM review_item_status_v FOR igops.review_item_status_v;

GRANT SELECT ON igops.shared_accounts_v TO ig_report_role;
CREATE PUBLIC SYNONYM shared_accounts_v FOR igops.shared_accounts_v;

GRANT SELECT ON igops.application_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM application_parameter_v FOR igops.application_parameter_v;

GRANT SELECT ON igops.permission_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM permission_parameter_v FOR igops.permission_parameter_v;

GRANT SELECT ON igops.review_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM review_parameter_v FOR igops.review_parameter_v;

GRANT SELECT ON igops.reviewer_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM reviewer_parameter_v FOR igops.reviewer_parameter_v;

GRANT SELECT ON igops.role_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM role_parameter_v FOR igops.role_parameter_v;

GRANT SELECT ON igops.user_parameter_v TO ig_report_role;
CREATE PUBLIC SYNONYM user_parameter_v FOR igops.user_parameter_v;